/* demo1.c
 * -------
 * Simple demonstration of the Zynq and Epiphany as OpenMP4.0 devices.
 *
 * The OMPi team, 2014.
 */

#include <omp.h>
#include <stdio.h>


void demo_devices()
{
	int i, isinitial;

	/* Diagnostics */
	printf("Available devices:    %d\n", omp_get_num_devices());
	printf("Default device:       %d\n", omp_get_default_device());
	for (i = 0; i < omp_get_num_devices(); i++)
	{
		printf("Kernel check @ device %d ", i);
		#pragma omp target device(i) map(from:isinitial) 
		{
			isinitial = omp_is_initial_device();
		}
		printf(isinitial ? "(zynq)\n" : "(epiphany)\n");
	}
}


void main()
{
	demo_devices();
}

