/* demo2.c
 * -------
 * Another simple demonstration of the Zynq and Epiphany as OpenMP4.0 devices.
 *
 * The OMPi team, 2014.
 */

#include <omp.h>
#include <stdio.h>


void demo_devices()
{
	int i;
	int where[20];

	/* Diagnostics */
	printf("Available devices:    %d\n", omp_get_num_devices());
	printf("Default device:       %d\n", omp_get_default_device());

	/* Spawn 20 OpenMP threads on Zynq */
	#pragma omp parallel num_threads(20)
	{
		int on_Zynq, tid = omp_get_thread_num();
		
		/* Kernel 0 and 10 should execute @Zynq, rest @ default device */
		#pragma omp target map(from:on_Zynq) if(tid%10 != 0)
		{
			on_Zynq = omp_is_initial_device();
		}
		
		where[tid] = on_Zynq;
	}
	
	for(i=0; i<20; i++)
		printf("Kernel %d executed on %s\n", i, where[i] ? "Zynq" : "Epiphany");
}


void main()
{
	demo_devices();
}

